﻿Imports System
Imports System.Windows.Forms
Imports GTA

Public Class EnemyCarGangScript
    Inherits Script
    Private ScriptTog As Boolean = False
    Private CantDie As Boolean = False
    Private NoStars As Boolean = False
    Private Const HEALTH_VALUE As Integer = 100
    Private Group As Group = Player.Group


    Public Sub New()
        Interval = 250
        World.PedDensity = 2.0
        Bindkey(Keys.F7, AddressOf ToggleScript)
        
        
    End Sub
    Private Sub ToggleScript()
        ScriptTog = Not ScriptTog
        If ScriptTog Then
            settings.load()
            BindKey(Settings.GetValueKey("Spawn Patriot with Bodyguards", "SETTINGS", Keys.I), New KeyPressDelegate(AddressOf PlayerDriveByGang))
            BindKey(Settings.GetValueKey("Rival Drive By Gang", "SETTINGS", Keys.M), New KeyPressDelegate(AddressOf EnemyCarGang))
            BindKey(Settings.GetValueKey("Look For Psychos", "SETTINGS", Keys.N), New KeyPressDelegate(AddressOf ClosestPedAsPsycho))
            BindKey(Settings.GetValueKey("Refill Health and Armor", "SETTINGS", Keys.J), New KeyPressDelegate(AddressOf RefillHealth))
            BindKey(Settings.GetValueKey("Police Will Ignore You", "SETTINGS", Keys.K), New KeyPressDelegate(AddressOf StarScript))
            BindKey(Settings.GetValueKey("Get Closest Ped as Bodyguard", "SETTINGS", Keys.U), New KeyPressDelegate(AddressOf ClosestPedAsBodyGuard))
            BindKey(Settings.GetValueKey("Remove Bodyguards", "SETTINGS", Keys.L), New KeyPressDelegate(AddressOf RemoveBodyGuards))
            BindKey(Settings.GetValueKey("Fill Weapon Inventory", "SETTINGS", Keys.Y), New KeyPressDelegate(AddressOf GoodWeapons))
            Game.displaytext("RivalDriveByGang Activated")
        Else
            unBindKey(Keys.F7)
        End If

    End Sub




    Private Sub PlayerDriveByGang()




        Dim v As Vehicle = World.CreateVehicle("Patriot", Player.Character.Position)

        If Exists(v) Then
            Player.Character.WarpIntoVehicle(v, VehicleSeat.Driver)
            v.color = colorindex.CabernetRedPoly
            v.createpedonseat(vehicleseat.rightfront)
            v.createpedonseat(vehicleseat.rightrear)
            v.createpedonseat(vehicleseat.leftrear)
            v.CanTiresBurst = False
            v.EngineHealth = 1000
            v.PetrolTankHealth = 1000
            v.dirtyness = 0
            v.NoLongerNeeded()



            For Each Member As Ped In Group
                Member.Weapons.RemoveAll()
                Member.task.WanderAround()

            Next
            game.displaytext("Vigilantes On Foot Dispersed")
            Group.RemoveAllMembers()


        End If





        If exists(v) Then
            wait(1000)
            For I As Integer = 0 To 0

                Dim p As Ped = v.getpedonseat(vehicleseat.rightfront)
                If exists(p) Then

                    game.displaytext("Driving Gang Assembled")
                    p.WillDoDrivebys = True
                    p.PriorityTargetForEnemies = True
                    p.CurrentRoom = Player.Character.CurrentRoom
                    p.CanSwitchWeapons = True
                    p.DuckWhenAimedAtByGroupMember = True
                    p.SetPathfinding(True, True, True)
                    p.WillUseCarsInCombat = True
                    p.Accuracy = 100
                    p.MaxHealth = 100
                    p.Armor = 100
                    p.WillFlyThroughWindscreen = True


                    Dim weap As Weapon = Player.Character.Weapons.Current
                    p.Weapons(weap).Ammo = 99999
                    p.Weapons.MP5.Ammo = 99999
                    p.Weapons.Select(weap)

                    p.RelationshipGroup = RelationshipGroup.Player
                    p.CantBeDamagedByRelationshipGroup(RelationshipGroup.Player, False)
                    Group.AddMember(p)
                End If
            Next
        End If

        If exists(v) Then
            For I As Integer = 0 To 0

                Dim p As Ped = v.getpedonseat(vehicleseat.rightrear)
                If exists(p) Then
                    p.WillDoDrivebys = True
                    p.PriorityTargetForEnemies = True
                    p.CurrentRoom = Player.Character.CurrentRoom
                    p.CanSwitchWeapons = True
                    p.DuckWhenAimedAtByGroupMember = True
                    p.SetPathfinding(True, True, True)
                    p.WillUseCarsInCombat = True
                    p.Accuracy = 100
                    p.MaxHealth = 100
                    p.Armor = 100
                    p.WillFlyThroughWindscreen = True


                    Dim weap As Weapon = Player.Character.Weapons.Current
                    p.Weapons(weap).Ammo = 99999
                    p.Weapons.Uzi.Ammo = 99999
                    p.Weapons.Select(weap)

                    p.RelationshipGroup = RelationshipGroup.Player
                    p.CantBeDamagedByRelationshipGroup(RelationshipGroup.Player, False)
                    Group.AddMember(p)
                End If

            Next
        End If

        If exists(v) Then
            For I As Integer = 0 To 0

                Dim p As Ped = v.getpedonseat(vehicleseat.leftrear)
                If exists(p) Then
                    p.WillDoDrivebys = True
                    p.PriorityTargetForEnemies = True
                    p.CurrentRoom = Player.Character.CurrentRoom
                    p.CanSwitchWeapons = True
                    p.DuckWhenAimedAtByGroupMember = True
                    p.SetPathfinding(True, True, True)
                    p.WillUseCarsInCombat = True
                    p.Accuracy = 100
                    p.MaxHealth = 100
                    p.Armor = 100
                    p.WillFlyThroughWindscreen = True


                    Dim weap As Weapon = Player.Character.Weapons.Current
                    p.Weapons(weap).Ammo = 99999
                    p.Weapons.DesertEagle.Ammo = 99999
                    p.Weapons.Select(weap)

                    p.RelationshipGroup = RelationshipGroup.Player
                    p.CantBeDamagedByRelationshipGroup(RelationshipGroup.Player, False)
                    Group.AddMember(p)
                End If

            Next
        End If





    End Sub



    Private Sub AddToGroup(ByVal p As Ped)
        If Not Exists(p) Then Return
        If Group.isMember(p) Then Return

        p.WillDoDrivebys = True
        p.PriorityTargetForEnemies = True
        p.CurrentRoom = Player.Character.CurrentRoom
        p.CanSwitchWeapons = True
        p.DuckWhenAimedAtByGroupMember = True
        p.SetPathfinding(True, True, True)
        p.WillUseCarsInCombat = True
        p.Accuracy = 100
        p.Health = 100
        p.Armor = 100
        p.WillFlyThroughWindscreen = True


        Dim weap As Weapon = Player.Character.Weapons.Current
        p.Weapons(weap).Ammo = 99999
        p.Weapons.MP5.Ammo = 99999
        p.Weapons.Select(weap)

        p.RelationshipGroup = RelationshipGroup.Player
        p.CantBeDamagedByRelationshipGroup(RelationshipGroup.Player, False)

        Group.AddMember(p)
    End Sub



    Private Sub EnemyCarGang()



        Dim v As Vehicle = World.GetClosestVehicle(Player.Character.GetOffsetPosition(New Vector3(0.0F, 27.0F, 0.0F)), 25.0F)



        If Not exists(v) Then
            game.displaytext("No Sign Of Trouble")


        End If
        If v.isDriveable = False Then
            game.displaytext("No Sign Of Trouble")
        End If



        If v.isDriveable = True Then


            v.nolongerneeded()
            v.PassengersLeaveVehicle(Immediately:=True)
            wait(500)
            v.createpedonseat(vehicleseat.driver)
            
            game.displaytext("Look Out! Here They Come!")









            For M As Integer = 0 To 0
                If exists(v) Then
                    wait(500)
                    Dim p As Ped = v.getpedonseat(vehicleseat.driver)
                    If exists(P) Then
                        If p.isinvehicle = True Then
                            p.BecomeMissionCharacter()
                            p.CurrentRoom = Player.Character.CurrentRoom
                            p.WillUseCarsInCombat = True
                            p.Health = 100
                            p.Armor = 100
                            p.Enemy = True
                            p.SetPathfinding(True, True, True)
                            p.WillFlyThroughWindscreen = False
                            p.CanBeKnockedOffBike = False
                            'p.MakeProofTo(True, False, False, False, False)
                            'p.AlwaysDiesOnLowHealth = True
                            p.Task.FightAgainst(Player)
                            'p.Task.CruiseWithVehicle(v, 65, False)

                            
                            p.Weapons.MP5.Ammo = 99999


                            p.RelationshipGroup = RelationshipGroup.Criminal
                            p.CantBeDamagedByRelationshipGroup(RelationshipGroup.Criminal, False)


                       
                        End If
                    End If
                End If


            Next


            For M As Integer = 0 To 0
                If Exists(v) Then

                    Dim p As Ped = v.createpedonseat(vehicleseat.rightrear)
                    If exists(p) Then
                        p.CurrentRoom = Player.Character.CurrentRoom
                        p.Health = 100
                        p.Armor = 100
                        p.Enemy = True
                        p.SetPathfinding(True, True, True)
                        p.WillFlyThroughWindscreen = False
                        p.CanBeKnockedOffBike = False
                        'p.WillDoDrivebys = True
                        'p.AlwaysDiesOnLowHealth = True
                        p.Task.FightAgainst(Player)

                        
                        p.Weapons.DesertEagle.Ammo = 99999


                        p.RelationshipGroup = RelationshipGroup.Criminal
                        p.CantBeDamagedByRelationshipGroup(RelationshipGroup.Criminal, False)
                    End If
                End If
            Next

            If exists(v) Then
                For M As Integer = 0 To 0

                    Dim p As Ped = v.createpedonseat(vehicleseat.leftrear)
                    If exists(p) Then
                        p.CurrentRoom = Player.Character.CurrentRoom
                        p.Health = 100
                        p.Armor = 100
                        p.Enemy = True
                        p.SetPathfinding(True, True, True)
                        p.WillFlyThroughWindscreen = False
                        p.CanBeKnockedOffBike = False
                        'p.WillDoDrivebys = True
                        'p.AlwaysDiesOnLowHealth = True
                        p.Task.FightAgainst(Player)


                        
                        p.Weapons.Uzi.Ammo = 99999


                        p.RelationshipGroup = RelationshipGroup.Criminal
                        p.CantBeDamagedByRelationshipGroup(RelationshipGroup.Criminal, False)
                    End If




                Next
                If exists(v) Then
                    For M As Integer = 0 To 0

                        Dim p As Ped = v.createpedonseat(vehicleseat.rightfront)
                        If exists(p) Then

                            p.CurrentRoom = Player.Character.CurrentRoom
                            p.Health = 100
                            p.Armor = 100
                            p.Enemy = True
                            p.SetPathfinding(True, True, True)
                            p.WillFlyThroughWindscreen = False
                            p.CanBeKnockedOffBike = False
                            'p.WillDoDrivebys = True
                            'p.AlwaysDiesOnLowHealth = True
                            p.Task.FightAgainst(Player)


                            
                            p.Weapons.MP5.Ammo = 99999


                            p.RelationshipGroup = RelationshipGroup.Criminal
                            p.CantBeDamagedByRelationshipGroup(RelationshipGroup.Criminal, False)
                        End If

                    Next



                End If

            End If

        End If



    End Sub

    Public Sub ClosestPedAsBodyGuard()

        Dim P As Ped = World.GetClosestPed(Player.Character.Position, 30.0F)
        If Not exists(p) Then
            game.displaytext("Nobody Eligible For Recruitment")
        End If
        If Exists(P) Then
            If Group.MemberCount < 7 Then
                p.BecomeMissionCharacter()
                p.RelationshipGroup = RelationshipGroup.Player
                addtogroup(p)
                game.displaytext("Vigilante Gang Member Recruited")
            End If
        End If

        If Group.MemberCount = 7 Then
            game.displaytext("Taking No More Members")
        End If
    End Sub


    Public Sub RemoveBodyGuards()

        For Each Member As Ped In Group
            Member.Weapons.RemoveAll()
            Member.task.WanderAround()

        Next
        game.displaytext("Vigilantes Dispersed")
        Group.RemoveAllMembers()


    End Sub

    Public Sub RefillHealth()
        CantDie = Not CantDie
        If CantDie Then

            Dim p As ped = player.character
            Player.MaxHealth = HEALTH_VALUE
            Player.MaxArmor = HEALTH_VALUE
            Player.Character.Health = HEALTH_VALUE
            Player.Character.Armor = HEALTH_VALUE
            game.displaytext("Invinciblity On")
            p.Invincible = True

        Else
            Dim p As ped = player.character
            Player.MaxHealth = HEALTH_VALUE
            Player.MaxArmor = HEALTH_VALUE
            Player.Character.Health = HEALTH_VALUE
            Player.Character.Armor = HEALTH_VALUE
            game.displaytext("Invinciblity Off")
            p.Invincible = False
        End If

    End Sub
    Public Sub GoodWeapons()
        game.displaytext("Filled Weapon Inventory")
        With Player.Character
            .Weapons.Knife.Ammo = 1
            .Weapons.MolotovCocktails.Ammo += 25
            .Weapons.DesertEagle.Ammo += 1500
            .Weapons.BarettaShotgun.Ammo += 80
            .Weapons.AssaultRifle_M4.Ammo += 600
            .Weapons.BasicSniperRifle.Ammo += 50 'for some reason brings up better SniperRifle_M40A1 
            .Weapons.MP5.Ammo += 1200
            .Weapons.RocketLauncher.Ammo += 8
        End With
    End Sub
    Private Sub NoFuzz_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Tick
        Me.interval = 20
        If NoStars Then
            If NoStars AndAlso Player.WantedLevel > 0 Then
                Player.WantedLevel = 0
            End If
            If NoStars AndAlso Player.WantedLevel = 0 Then
                Player.WantedLevel = 0

            End If
        End If
    End Sub
    

    Public Sub StarScript()

        NoStars = Not NoStars
        Dim p As ped = player.character

        If NoStars Then

            Player.WantedLevel = 0
            Game.WantedMultiplier = 0.0F
            Game.DisplayText("Police Will Not Engage")
            p.RelationshipGroup = RelationshipGroup.Cop

        Else
            Game.WantedMultiplier = 1.0F
            p.RelationshipGroup = RelationshipGroup.player
            Game.DisplayText("Police Will Engage")
        End If


    End Sub


    Public Sub ClosestPedAsPsycho()




        Dim P As Ped = World.GetClosestPed(Player.Character.Position, 50.0F)
        If Not Exists(p) Then
            game.displaytext("No Psychos In The Area")
        End If

        If Exists(P) Then

            game.displaytext("That One's Psychotic!")
            p.BecomeMissionCharacter()
            p.startkillingspree(alsoAttackPlayer:=True)
            p.CurrentRoom = Player.Character.CurrentRoom
            p.WillDoDrivebys = True
            p.PriorityTargetForEnemies = True
            p.CanSwitchWeapons = True
            p.DuckWhenAimedAtByGroupMember = True
            p.SetPathfinding(True, True, True)
            p.WillUseCarsInCombat = True
            p.enemy = True
            p.Accuracy = 100
            p.Health = 100
            p.Armor = 100
            p.WillFlyThroughWindscreen = True
            'p.WantedByPolice = True
            p.Task.FightAgainst(Player)




            p.Weapons.Uzi.Ammo = 99999
            


            p.RelationshipGroup = RelationshipGroup.Criminal
            p.CantBeDamagedByRelationshipGroup(RelationshipGroup.Criminal, False)

        End If





    End Sub
End Class

